from typing import Iterator

from sqlalchemy.future import Engine

from . import cryptography, database


def get_all_accounts(
    engine: Engine, user_id: int, master_pass: str
) -> Iterator[tuple[str, str, str]]:
    for account in database.get.get_all_accounts(engine, user_id):
        name, salt, enc_login, enc_passwd = account
        login, passwd = cryptography.other_accounts.decrypt_account_info(
            enc_login, enc_passwd, master_pass, salt
        )
        yield (name, login, passwd)
